# 4.5.0

Release date: `2020-12-15`

## Core

- [NXDRIVE-1724](https://jira.nuxeo.com/browse/NXDRIVE-1724): Use the `missing_ok` keyword argument for `unlink()`
- [NXDRIVE-2270](https://jira.nuxeo.com/browse/NXDRIVE-2270): [macOS] Big Sur support
- [NXDRIVE-2311](https://jira.nuxeo.com/browse/NXDRIVE-2311): Add an option to control doc types where Direct Transfer is disallowed
- [NXDRIVE-2319](https://jira.nuxeo.com/browse/NXDRIVE-2319): Do not use the undocumented and unreliable `Path.absolute()` method
- [NXDRIVE-2322](https://jira.nuxeo.com/browse/NXDRIVE-2322): Do not retry a HTTP call that failed on 500 error
- [NXDRIVE-2323](https://jira.nuxeo.com/browse/NXDRIVE-2323): Add `LOG_EVERYTHING` envar to ... log everything
- [NXDRIVE-2324](https://jira.nuxeo.com/browse/NXDRIVE-2324): Fix the transfer progression reset if it was paused at startup
- [NXDRIVE-2325](https://jira.nuxeo.com/browse/NXDRIVE-2325): Save the upload state when it is completed on the server
- [NXDRIVE-2336](https://jira.nuxeo.com/browse/NXDRIVE-2336): Fix `mypy` issues following the update to version 0.790
- [NXDRIVE-2338](https://jira.nuxeo.com/browse/NXDRIVE-2338): Enable performance monitoring on Sentry
- [NXDRIVE-2342](https://jira.nuxeo.com/browse/NXDRIVE-2342): Fix an implicit int -> float conversion deprecation warnings in `application.py`
- [NXDRIVE-2344](https://jira.nuxeo.com/browse/NXDRIVE-2344): [GNU/Linux] Use `os.*attr()` builtin functions instead of the `xattr` module
- [NXDRIVE-2360](https://jira.nuxeo.com/browse/NXDRIVE-2360): [GNU/Linux] Do not spawn a process for doing a simple `chmod`
- [NXDRIVE-2365](https://jira.nuxeo.com/browse/NXDRIVE-2365): Remove all database-related files on account removal
- [NXDRIVE-2368](https://jira.nuxeo.com/browse/NXDRIVE-2368): Bump the `chunk_limit` upper limit from 20 MiB to 5120 MiB (5 GiB)
- [NXDRIVE-2373](https://jira.nuxeo.com/browse/NXDRIVE-2373): Set the TCP keep alive option by default
- [NXDRIVE-2375](https://jira.nuxeo.com/browse/NXDRIVE-2375): Remove usages of the deprecated `Blob.batch_id` attribute for `batchId`
- [NXDRIVE-2377](https://jira.nuxeo.com/browse/NXDRIVE-2377): Force database commit before application exit
- [NXDRIVE-2385](https://jira.nuxeo.com/browse/NXDRIVE-2385): Ignore Arabic translations until fully ready
- [NXDRIVE-2397](https://jira.nuxeo.com/browse/NXDRIVE-2397): Small improvement for non-chunked uploads
- [NXDRIVE-2435](https://jira.nuxeo.com/browse/NXDRIVE-2435): Fix handling of direct PAC file input in proxy settings
- [NXDRIVE-2439](https://jira.nuxeo.com/browse/NXDRIVE-2439): Add more metrics to understand several keypoints

### Direct Edit

- [NXDRIVE-2337](https://jira.nuxeo.com/browse/NXDRIVE-2337): Use `Options.max_errors` for the retry count
- [NXDRIVE-2340](https://jira.nuxeo.com/browse/NXDRIVE-2340): Handle locking permission errors in the lock queue
- [NXDRIVE-2380](https://jira.nuxeo.com/browse/NXDRIVE-2380): Fix broken document preview when using the S3 upload provider
- [NXDRIVE-2384](https://jira.nuxeo.com/browse/NXDRIVE-2384): Remove usage of the deprecated `applyVersioningPolicy` operation parameter

### Direct Transfer

- [NXDRIVE-2309](https://jira.nuxeo.com/browse/NXDRIVE-2309): Implement Active Transfer sessions tab
- [NXDRIVE-2331](https://jira.nuxeo.com/browse/NXDRIVE-2331): Check for ignored patterns against lowercased names
- [NXDRIVE-2341](https://jira.nuxeo.com/browse/NXDRIVE-2341): Non-chunked uploads must be put in pause when the session is paused
- [NXDRIVE-2432](https://jira.nuxeo.com/browse/NXDRIVE-2432): Only display chunked transfers into the Monitoring tab
- [NXDRIVE-2433](https://jira.nuxeo.com/browse/NXDRIVE-2433): Remove pause button on the monitoring tab

## GUI

- [NXDRIVE-2076](https://jira.nuxeo.com/browse/NXDRIVE-2076): Change the cursor on click on new account connect button
- [NXDRIVE-2305](https://jira.nuxeo.com/browse/NXDRIVE-2305): Do not display the filters window on new account if the synchronization is disabled
- [NXDRIVE-2306](https://jira.nuxeo.com/browse/NXDRIVE-2306): Do not validate again settings when the value did not change
- [NXDRIVE-2346](https://jira.nuxeo.com/browse/NXDRIVE-2346): Link to the current OS installer in the fatal error window
- [NXDRIVE-2349](https://jira.nuxeo.com/browse/NXDRIVE-2349): Fix a QML margin in the account addition
- [NXDRIVE-2353](https://jira.nuxeo.com/browse/NXDRIVE-2353): Fix the window centering for multi-screen setup
- [NXDRIVE-2359](https://jira.nuxeo.com/browse/NXDRIVE-2359): Improve question message boxes rendering
- [NXDRIVE-2379](https://jira.nuxeo.com/browse/NXDRIVE-2379): Review how the GUI is repainted to fix a crash
- [NXDRIVE-2389](https://jira.nuxeo.com/browse/NXDRIVE-2389): Update Qt Quick Controls version for PyQt 5.15
- [NXDRIVE-2393](https://jira.nuxeo.com/browse/NXDRIVE-2393): Display a proper error message when the `nuxeo-drive` addon is not installed on the server
- [NXDRIVE-2416](https://jira.nuxeo.com/browse/NXDRIVE-2416): Update the Direct Transfer feature description

## Packaging / Build

- [NXDRIVE-2308](https://jira.nuxeo.com/browse/NXDRIVE-2308): Reduce the release process time
- [NXDRIVE-2312](https://jira.nuxeo.com/browse/NXDRIVE-2312): Upgrade Python from 3.7.9 to 3.8.6
- [NXDRIVE-2314](https://jira.nuxeo.com/browse/NXDRIVE-2314): Remove more files from the final package
- [NXDRIVE-2315](https://jira.nuxeo.com/browse/NXDRIVE-2315): Do not show the progress bar on module installation
- [NXDRIVE-2330](https://jira.nuxeo.com/browse/NXDRIVE-2230): [Windows] Do not alter boot start state from the installer when auto-updating the app
- [NXDRIVE-2347](https://jira.nuxeo.com/browse/NXDRIVE-2347): Fix packaging following the `sentry-sdk` upgrade to 0.19.0
- [NXDRIVE-2370](https://jira.nuxeo.com/browse/NXDRIVE-2370): Allow dependabot to check GitHub actions monthly
- [NXDRIVE-2390](https://jira.nuxeo.com/browse/NXDRIVE-2390): Improve the final package clean-up script
- [NXDRIVE-2391](https://jira.nuxeo.com/browse/NXDRIVE-2391): [macOS] Add required entitlement for Apple events
- [NXDRIVE-2395](https://jira.nuxeo.com/browse/NXDRIVE-2395): [Windows] Upgrade `Inno Setup` from 6.0.5 to 6.1.2
- [NXDRIVE-2396](https://jira.nuxeo.com/browse/NXDRIVE-2396): Switch to the new `Dependabot` config file
- [NXDRIVE-2398](https://jira.nuxeo.com/browse/NXDRIVE-2398): Upgrade `PyInstaller` to 4.1
- [NXDRIVE-2399](https://jira.nuxeo.com/browse/NXDRIVE-2399): Temporary stop releasing a GNU/Linux version
- [NXDRIVE-2401](https://jira.nuxeo.com/browse/NXDRIVE-2401): Upgrade the Docker build workflow to the new action version
- [NXDRIVE-2452](https://jira.nuxeo.com/browse/NXDRIVE-2452): Add release dates in `versions.yml`

## Tests

- [NXDRIVE-2071](https://jira.nuxeo.com/browse/NXDRIVE-2071): Use GitHub Actions to run functional tests
- [NXDRIVE-2111](https://jira.nuxeo.com/browse/NXDRIVE-2111): Use GitHub Actions to run integration tests
- [NXDRIVE-2316](https://jira.nuxeo.com/browse/NXDRIVE-2316): Skip the synchronization in the auto-update check script
- [NXDRIVE-2326](https://jira.nuxeo.com/browse/NXDRIVE-2326): Fix test `test_get_metadata_infos()`
- [NXDRIVE-2339](https://jira.nuxeo.com/browse/NXDRIVE-2339): Tell `test_proxy.py` to use a temporary folder instead of the current directory
- [NXDRIVE-2345](https://jira.nuxeo.com/browse/NXDRIVE-2345): Fix `test_site_update_url()`
- [NXDRIVE-2348](https://jira.nuxeo.com/browse/NXDRIVE-2348): Fix `test_updater.py`
- [NXDRIVE-2376](https://jira.nuxeo.com/browse/NXDRIVE-2376): Use the dedicated test server whenever possible
- [NXDRIVE-2434](https://jira.nuxeo.com/browse/NXDRIVE-2434): [macOS] Fix `NSError` object has no attribute `utf8ValueSafe`

## Docs

- [NXDRIVE-2318](https://jira.nuxeo.com/browse/NXDRIVE-2318): Sync the documentation between that repository and [doc.nuxeo.com](https://doc.nuxeo.com/client-apps/nuxeo-drive/)

## Minor Changes

- Added a custom `.gitattributes` file
- Added `pyinstaller-hooks-contrib` 2020.10
- Upgraded `boto3` from 1.14.0 to 1.16.25
- Upgraded `botocore` from 1.17.0 to 1.19.25
- Upgraded `certifi` from 2020.6.20 to 2020.12.5
- Upgraded `cffi` from 1.14.2 to 1.14.4
- Upgraded `docutils` from 0.15.2 to 0.16
- Upgraded `nuxeo` from 3.0.1 to 4.0.0
- Upgraded `pip` from 20.2.3 to 20.2.4
- Upgraded `psutil` from 5.6.7 to 5.7.3
- Upgraded `pycryptodomex` from 3.9.8 to 3.9.9
- Upgraded `pyinstaller` from commit-41237b1 to 4.1
- Upgraded `pyobjc-core` from 6.2.2 to 7.0.1
- Upgraded `pyobjc-framework-cocoa` from 6.2.2 to 7.0.1
- Upgraded `pyobjc-framework-coreservices` from 6.2.2 to 7.0.1
- Upgraded `pyobjc-framework-fsevents` from 6.2.2 to 7.0.1
- Upgraded `pyobjc-framework-scriptingbridge` from 6.2.2 to 7.0.1
- Upgraded `pyobjc-framework-systemconfiguration` from 6.2.2 to 7.0.1
- Upgraded `pypac` from 0.13.0 to 0.14.0
- Upgraded `pyqt5` from 5.15.0 to 5.15.1
- Upgraded `pywin32` from 228 to 300
- Upgraded `requests` from 2.24.0 to 2.25.0
- Upgraded `s3transfer` from 0.3.2 to 0.3.3
- Upgraded `sentry-sdk` from 0.17.3 to 0.19.5
- Upgraded `urllib3` from 1.25.10 to 1.26.2
- Upgraded `zipp` from 3.1.0 to 3.4.0

## Technical Changes

- Added `AbstractOSIntegration.startup_enabled()`
- Changed `AbstractOSIntegration.register_startup()` return type from `bool` to `None`
- Changed `AbstractOSIntegration.unregister_startup()` return type from `bool` to `None`
- Added `Application.confirm_cancel_session()`
- Added `Application.question()`
- Added `Application.refresh_active_sessions_items()`
- Added `Application.refresh_completed_sessions_items()`
- Removed `Application.update_direct_transfer_items_count()`
- Added `chunked` argument to `BaseUploader.link_blob_to_doc()`
- Added `transfer` argument to `BaseUploader.link_blob_to_doc()`
- Added `blob` argument to `BaseUploader.upload_chunks()`
- Added `chunked` argument to `BaseUploader.upload_chunks()`
- Added `transfer` argument to `BaseUploader.upload_chunks()`
- Removed `mime_type` keyword argument from `BaseUploader.upload()`
- Removed `file_path` argument from `BaseUploader.upload_chunks()`. Use `transfer.path` instead.
- Removed `filename` keyword argument from `BaseUploader.upload_chunks()`
- Removed `mime_type` keyword argument from `BaseUploader.upload_chunks()`
- Removed `kwargs` keyword arguments from `BaseUploader.upload_chunks()`
- Removed `mime_type` keyword argument from `BaseUploader.upload_impl()`
- Added `ConfigurationDAO.force_commit()`
- Added `DarwinIntegration.startup_enabled()`
- Changed `DarwinIntegration.register_startup()` return type from `bool` to `None`
- Changed `DarwinIntegration.unregister_startup()` return type from `bool` to `None`
- Removed `mime_type` keyword argument from `DirectTransferUploader.upload()`
- Added `Engine.cancel_session()`
- Added `Engine.resume_session()`
- Added `Engine.send_metric()`
- Removed `Engine.directTranferItemsCount`
- Added `EngineDAO.change_session_status()`
- Added `description` keyword argument to `EngineDAO.create_session()`
- Added `engine_uid` keyword argument to `EngineDAO.create_session()`
- Added `EngineDAO.get_active_sessions_raw()`
- Added `EngineDAO.get_completed_sessions_raw()`
- Added `table` keyword argument to `EngineDAO.get_count()`
- Added `chunked` keyword argument to `EngineDAO.get_dt_uploads_raw()`
- Added `EngineDAO.pause_session()`
- Added `EngineDAO.save_dt_upload()`
- Added `EngineDAO.sessionUpdated`
- Removed `EngineDao.decrease_session_total()`. Use `decrease_session_counts()` instead.
- Changed `Manager.set_auto_start()` return type from `bool` to `None`
- Added `Options.disallowed_types_for_dt`
- Added `page_size` keyword argument to `Remote.query()`
- Removed `mime_type` keyword argument from  `Remote.stream_file()`
- Added `Session.completed_on`
- Added `Session.created_on`
- Added `Session.description`
- Added `Session.engine`
- Added `Session.planned_items`
- Removed `mime_type` keyword argument from `SyncUploader.upload()`
- Added `QMLDriveApi.cancel_session()`
- Added `QMLDriveApi.get_active_sessions_count()`
- Added `QMLDriveApi.get_active_sessions_items()`
- Added `QMLDriveApi.get_completed_sessions_count()`
- Added `QMLDriveApi.get_completed_sessions_items()`
- Added `QMLDriveApi.get_remote_document_url()`
- Added `QMLDriveApi.open_server_folders()`
- Added `QMLDriveApi.pause_session()`
- Added `QMLDriveApi.resume_session()`
- Changed `QMLDriveApi.set_auto_start()` return type from `bool` to `None`
- Removed `QMLDriveApi.get_dt_items_count()`
- Added `Tracker.send_metric()`
- Added `TransferStatus.CANCELLED`
- Added `Upload.batch_obj`
- Added `WindowsIntegration.startup_enabled()`
- Changed `WindowsIntegration.register_startup()` return type from `bool` to `None`
- Changed `WindowsIntegration.unregister_startup()` return type from `bool` to `None`
- Removed `cls` keyword argument from utils.py::`normalized_path()`
- Added constants.py::`DT_ACTIVE_SESSIONS_MAX_ITEMS`
- Added constants.py::`DT_MONITORING_MAX_ITEMS`
- Added exceptions.py::`AddonNotInstalledError`
- Added exceptions.py::`TransferCancelled`
- Added exceptions.py::`UploadCancelled`
- Added view.py::`ActiveSessionModel`
- Added view.py::`CompletedSessionModel`
